// physicalobjecttracker.h
//
// cre: 2012-02-18
// aut: JGS
//
// (C) 2012 EVOLViA

#include "etherealobject.h"
#include "physicalobject.h"
#include "vector3.h"
#include <vector>

class PhysicalObjectTracker : public EtherealObject
{
	PhysicalObject &
		d_object;

	std::vector<Vector3>
		d_position;

	public:

		PhysicalObjectTracker(PhysicalObject &object)
		: d_object(object)
		{
			d_position.push_back(object.position());
		}

		virtual void step(double dt)
		{
			d_position.push_back(d_object.position());
		}

		Vector3 const & operator [] (unsigned idx) const
		{
			return d_position[idx];
		}

		size_t size() const
		{
			return d_position.size();
		}
};

